## Calling Instance module to provision single Virtual Machine

module "Instances" {
  ## Source reference to local module
  source = ".//modules//instance"

  ## Instance Specific variables
  instance_name     = var.instance_name
  deployment_region = var.deployment_region
  instance_type     = var.instance_type

  userdata = filebase64("${path.module}//configUserData.json")
  keyname  = var.keyname

  ## Ensure Stack Name is unique for each VM
  stack_name = var.stack_name

  ## Network specific variables
  vpc_id = var.vpc_id

  external_subnet_id = var.external_subnet_id
  internal_subnet_id = var.internal_subnet_id

}