## Generating EIP for the Instance

resource "aws_eip" "eip01" {
  domain = "vpc"
}

resource "aws_eip" "eip02" {
  domain = "vpc"
}

## Creating EIP associations with External Interface

resource "aws_eip_association" "eip_association01" {
  allocation_id        = aws_eip.eip01.allocation_id
  network_interface_id = aws_network_interface.external_interface.id
  private_ip_address   = element(tolist(aws_network_interface.external_interface.private_ip_list), 1)

  depends_on = [
    aws_network_interface.external_interface,
    aws_eip.eip01,
  ]
}

resource "aws_eip_association" "eip_association02" {
  allocation_id        = aws_eip.eip02.allocation_id
  network_interface_id = aws_network_interface.external_interface.id
  private_ip_address   = aws_network_interface.external_interface.private_ip

  depends_on = [
    aws_network_interface.external_interface,
    aws_eip.eip02,
  ]
}