## Creating Network Interfaces for Virtual Machine

resource "aws_network_interface" "external_interface" {
  description       = "csc-gre-single-external-interface"
  security_groups   = [aws_security_group.external-sg.id]
  subnet_id         = var.external_subnet_id
  private_ips_count = 1

  tags = {
    "Name" = "csc-gre-single-external-interface-${var.instance_name}"
  }
}

resource "aws_network_interface" "internal_interface" {
  description       = "csc-gre-single-internal-interface"
  security_groups   = [aws_security_group.internal-sg.id]
  subnet_id         = var.internal_subnet_id
  source_dest_check = false
  private_ips_count = 2

  tags = {
    "Name" = "csc-gre-single-internal-interface-${var.instance_name}"
  }
}