## Create External Security Group

resource "aws_security_group" "external-sg" {
  name        = "csc-sg-external-${var.stack_name}"
  description = "csc-sg-external-${var.stack_name}"
  vpc_id      = var.vpc_id

  tags = {
    Name = "csc-sg-external-${var.stack_name}"
  }
}

## Creating Outbound rules for External Security Group

resource "aws_security_group_rule" "rule_80" {
  type              = "egress"
  from_port         = 80
  to_port           = 80
  protocol          = "tcp"
  cidr_blocks       = ["0.0.0.0/0"]
  security_group_id = aws_security_group.external-sg.id
}

resource "aws_security_group_rule" "rule_53" {
  type              = "egress"
  from_port         = 53
  to_port           = 53
  protocol          = "udp"
  cidr_blocks       = ["0.0.0.0/0"]
  security_group_id = aws_security_group.external-sg.id
}

resource "aws_security_group_rule" "rule_443" {
  type              = "egress"
  from_port         = 443
  to_port           = 443
  protocol          = "tcp"
  cidr_blocks       = ["0.0.0.0/0"]
  security_group_id = aws_security_group.external-sg.id
}

resource "aws_security_group_rule" "rule_1024" {
  type              = "egress"
  from_port         = 1024
  to_port           = 65535
  protocol          = "tcp"
  cidr_blocks       = ["0.0.0.0/0"]
  security_group_id = aws_security_group.external-sg.id
}

resource "aws_security_group_rule" "rule_47" {
  type              = "egress"
  from_port         = -1
  to_port           = -1
  protocol          = "47"
  cidr_blocks       = ["0.0.0.0/0"]
  security_group_id = aws_security_group.external-sg.id
}

resource "aws_security_group_rule" "rule_123" {
  type              = "egress"
  from_port         = 123
  to_port           = 123
  protocol          = "udp"
  cidr_blocks       = ["0.0.0.0/0"]
  security_group_id = aws_security_group.external-sg.id
}

resource "aws_security_group_rule" "rule_icmp" {
  type              = "egress"
  from_port         = -1
  to_port           = -1
  protocol          = "icmp"
  cidr_blocks       = ["0.0.0.0/0"]
  security_group_id = aws_security_group.external-sg.id
}

## Create Internal Security Group

resource "aws_security_group" "internal-sg" {
  name        = "csc-sg-internal-${var.stack_name}"
  description = "csc-sg-internal-${var.stack_name}"
  vpc_id      = var.vpc_id

  tags = {
    Name = "csc-sg-internal-${var.stack_name}"
  }
}

## Creating Inbound rules for Internal Security Group

resource "aws_security_group_rule" "rule_in_08" {
  type              = "ingress"
  protocol          = "-1"
  from_port         = -1
  to_port           = -1
  cidr_blocks       = ["10.0.0.0/8"]
  security_group_id = aws_security_group.internal-sg.id
}

resource "aws_security_group_rule" "rule_in_12" {
  type              = "ingress"
  protocol          = "-1"
  from_port         = -1
  to_port           = -1
  cidr_blocks       = ["172.16.0.0/12"]
  security_group_id = aws_security_group.internal-sg.id
}

resource "aws_security_group_rule" "rule_in_16" {
  type              = "ingress"
  protocol          = "-1"
  from_port         = -1
  to_port           = -1
  cidr_blocks       = ["192.168.0.0/16"]
  security_group_id = aws_security_group.internal-sg.id
}

resource "aws_security_group_rule" "rule_out_16" {
  type              = "egress"
  protocol          = "-1"
  from_port         = -1
  to_port           = -1
  cidr_blocks       = ["0.0.0.0/0"]
  security_group_id = aws_security_group.internal-sg.id
}