## Output values for the provisioned Infrastructure

output "VPC" {
  value       = var.vpc_id
  description = "A reference to the selected VPC."
}

output "ElasticIPs" {
  value       = module.Instances.ElasticIPs
  description = "A list of the Elastic IPs"
}

output "ExternalSubnet" {
  value       = var.external_subnet_id
  description = "External Subnet"
}

output "InternalSubnet" {
  value       = var.internal_subnet_id
  description = "Internal Subnet"
}

output "ExternalNetworkInterfacePrimaryIP" {
  value       = module.Instances.external_primary_ip
  description = "Primary IP of the External Network Interface"
}

output "ExternalNetworkInterfaceSecondaryIP" {
  value       = module.Instances.external_secondary_ip
  description = "Secondary IP of the External Network Interface"
}

output "InternalNetworkInterfacePrimaryIP" {
  value       = module.Instances.internal_primary_ip
  description = "Primary IP of the Internal Network Interface"
}

output "InternalNetworkInterfaceSecondaryIP" {
  value       = module.Instances.internal_secondary_ip
  description = "Secondary IP of the Internal Network Interface"
}

output "InternalSecurityGroup" {
  value       = "csc-sg-internal-${var.stack_name}"
  description = "Name of the Internal Security Group"
}

output "ExternalSecurityGroup" {
  value       = "csc-sg-external-${var.stack_name}"
  description = "Name of the External Security Group"
}

output "InternalNetworkInterface" {
  value       = "csc-gre-single-internal-interface-${var.stack_name}"
  description = "Name of the Internal Network Interface"
}

output "ExternalNetworkInterface" {
  value       = "csc-gre-single-external-interface-${var.stack_name}"
  description = "Name of the External Network Interface"
}

output "InstanceID" {
  value       = module.Instances.InstanceID
  description = "Instance ID"
}