## Creating Variables for Base module. You can add default values for each variable mentioned below, if not declared values will be picked from terraform.auto.tfvars file.

variable "vpc_id" {
  description = "Select VPC ID to use"
}

variable "external_subnet_id" {
  description = "Select an External Subnet (WARNING !! must be on the same availability zone as Internal Subnet)"
}

variable "internal_subnet_id" {
  description = "Select an Internal Subnet (WARNING !! must be on the same availability zone as Internal Subnet)"
}

variable "stack_name" {
  description = "Stack name for deployment"
}

variable "deployment_region" {
  description = "Region to deploy the infrastructure in"
}

variable "instance_name" {
  description = "The name of the Instance"
  type        = string
}

variable "instance_type" {
  description = "Select one of the instance types"
  type        = string
  default     = "t2.medium"
  validation {
    condition     = contains(["t2.small", "t2.medium", "t2.large", "t3a.small", "t3a.medium", "t3a.large", "t3.small", "t3.medium", "t3.large", "m5.large", "m5n.large", "m5zn.large", "m5a.xlarge","m5.xlarge", "m5n.xlarge", "m5zn.xlarge"], var.instance_type)
    error_message = "Argument 'instance_type' must one of t2.small, t2.medium, t2.large, t3a.small, t3a.medium, t3a.large, t3.small, t3.medium, t3.large, m5.large, m5n.large, m5zn.large, m5a.xlarge,m5.xlarge, m5n.xlarge, m5zn.xlarge"
  }
}

variable "keyname" {
  description = "Key Pair Name"
}

variable "userdata" {
  description = "(Optional) Advanced Deployment: Paste here configUserData.json file content values"
  type        = string
  default     = ""
}